#include <GL/glut.h>

// Zobrazenie štvorca
void display() {
	// Vyčistenie pozadia
	glClear(GL_COLOR_BUFFER_BIT);

	// Zapnutie výpočtu osvetlenia
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	// Nastavenie ambientného osvetlenia intenzity 0.1, difúzneho 1.0
	// a umiestnenie svetla do pravého horného rohu
	GLfloat light_ambient[] = {0.1, 0.1, 0.1, 1.0};
	GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};
	GLfloat light_specular[] = {0.0, 0.0, 0.0, 1.0};
	GLfloat light_position[] = {0.9, 0.9, 0.5, 1.0};

	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);

	// Útlm počítaný z prevrátených štvorcov
	glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 2.0);
	glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 1.0);
	glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.5);

	GLfloat material_specular[] = {0.0, 0.0, 0.0, 1.0};
	GLfloat material_shininess[] = {50.0};
	glMaterialfv(GL_FRONT, GL_SPECULAR, material_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, material_shininess);

	// Vykreslenie trojuholníkov s nastavením farby pre odraz ambientného
	// a difúzneho svetla
	glBegin(GL_TRIANGLE_STRIP);
		GLfloat color1[] = {1.0, 0.0, 0.0, 1.0};
		glMaterialfv(GL_FRONT, GL_AMBIENT, color1);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, color1);
		glVertex3f(-0.9, -0.9, 0);

		GLfloat color2[] = {0.0, 1.0, 0.0, 1.0};
		glMaterialfv(GL_FRONT, GL_AMBIENT, color2);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, color2);
		glVertex3f(-0.9, 0.9, 0);

		GLfloat color3[] = {0.0, 0.0, 1.0, 1.0};
		glMaterialfv(GL_FRONT, GL_AMBIENT, color3);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, color3);
		glVertex3f(0.9, -0.9, 0);

		GLfloat color4[] = {1.0, 1.0, 1.0, 1.0};
		glMaterialfv(GL_FRONT, GL_AMBIENT, color4);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, color4);
		glVertex3f(0.9, 0.9, 0);
	glEnd();

	// Ukončenie definície objektov a vykreslenie na obrazovku
	glFlush();
}

int main(int argc, char** argv) {

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);

	glutInitWindowSize(400, 300);
	glutCreateWindow("Okno");

	glutDisplayFunc(display);

	glutMainLoop();
}
